#include <cmath>
#include <chrono>
#include <iostream>
#include <numeric>
#include <utility>
#include <vector>

double distancia(double x1, double y1, double x2, double y2)
{
   auto dx = x2 - x1;
   auto dy = y2 - y1;
   return std::sqrt(dx * dx + dy * dy);
}

double distancia(std::pair<double, double> a, std::pair<double, double> b)
{
   return distancia(a.first, a.second, b.first, b.second);
}

int main( )
{
   int n;
   std::cin >> n;

   std::pair<double, double> ciudades[n];
   for (int i = 0; i < n; ++i) {
      std::cin >> ciudades[i].first >> ciudades[i].second;
   }

   int actual = 0;
   std::vector<int> faltantes(n - 1);
   std::iota(faltantes.begin( ), faltantes.end( ), 1);
   double res = 0;

   auto t0 = std::chrono::high_resolution_clock::now( );
   for (int i = 0; i < n - 1; ++i) {
      int posicion = 0;
      for (int j = 1; j < faltantes.size( ); ++j) {
         if (distancia(ciudades[actual], ciudades[faltantes[j]]) < distancia(ciudades[actual], ciudades[faltantes[posicion]])) {
             posicion = j;
         }
      }

      res += distancia(ciudades[actual], ciudades[faltantes[posicion]]);
      actual = faltantes[posicion];
      faltantes[posicion] = faltantes.back( );
      faltantes.pop_back( );
   }
   auto t1 = std::chrono::high_resolution_clock::now( );

   std::cout << res << '\n';
   std::cout << std::chrono::duration_cast<std::chrono::duration<double>>(t1 - t0).count( ) << '\n';
}
